const UserChat = require('../../models/userChat');
const RoomMember = require('../../models/roomMember');
const Room = require('../../models/room');
const RequestSupport = require('../../models/requestSupport');
const Message = require('../../models/message');
const Media = require('../../models/media');
const User = require('../../models/user');
const messageText = require('../../models/messageText');
const {sequelize, DataTypes} = require("../../utiles/database");
const helper = require('../../utiles/helper');
const {isEmpty} = require("lodash");
const customNotifcation = require("../FirebaseNotification/custom-notifcation")
const fileType = require("file-type");
const {dirname} = require("path");
const fs = require("fs");



exports.send = (socket, userId, roomId,Requestsupport) => {

    ///////////////[Start JOIN CHAT]////////////////////
    socket.on("send-socket-id", () => {
        console.log(socket.id)
        socket.socketID = socket.id;


        // socket.join(socket.socketID);
        // console.log("********************************new room created with ID " + socket.socketID + " user Id" + userId)
    })

    socket.on('send-message', async (data) => {

        console.log("................" + data.user_id)
        console.log("................" + data.room_id)

        const room = Room.findOne({
            where: {room_id: roomId}
        }).then(userData => {
           UserChat.findAll({
               where : { room_id : !userData.id}
           })
        }).then(data => {
                Message.findAll({
                    where : { seen:0 }
                }).then(res => {
                    Requestsupport.emit("newMessage", {"new": "newMessage"});
                });
            });
        console.log(roomId);
        // helper.check_path("Message");
        // let RoomData = await RoomMember.findOne({where: {room_id:roomId}});.log()
        return sequelize.transaction(async function (t) {

            //get room data
            let RoomData = await Room.findOne({where: {room_id: roomId}});
            console.log(await RequestSupport.findAll());
            // get room member
            // console.log(RoomData);
            let receive = null;
            //user
            let UserData = await User.findOne({where: {id: userId}});
                    let RoomMember = await sequelize.query("SELECT user_id from room_members where room_id=" + RoomData.id + " and user_id !=" + userId, {type: sequelize.QueryTypes.SELECT});
                if (RoomMember.length !== 0) {
                    receive = RoomMember[0].userId;
                    console.log("test+++++++++++++++++++++++", RoomMember)
                }


            // // add user
            await UserChat.create({
                user_id: userId,
                room_id: RoomData.id,
            }, {transaction: t}).then(async (U_Chat) => {
                console.log("add success");
                let DataType =getMainType(data);

                await Message.create({
                    user_chat_id: U_Chat.id,
                    type: DataType,
                    seen: 0
                }, {transaction: t}).then(async (M_caht) => {


                    let ext = null;
                    let media_type = [];
                    let Array_buff = [];

                    // // image
                    if (data.image && !isEmpty(data.image)) {
                        console.log("i am in media")

                        if (Array.isArray(data.image)) {
                            $array_base64 = data.image;

                            for (const element of $array_base64) {
                                let buff = Buffer.from(element, 'base64');
                                ext = await fileType.fromBuffer(new Buffer(element, 'base64'));
                                media_type.push(await helper.getMediaType(ext.mime));
                                Array_buff.push(buff);

                            }
                            await helper.saveImage(Array_buff, M_caht.id, DataType, socket, data, media_type, UserData.type, UserData.id,roomId, UserData.name, receive);

                        } else {
                            console.log("singel");
                        }
                    } else {
                    //

                        socket.emit("success", {"type": 1, "media_type": []})
                        // ChatNamespace.emit("new-support", {Cus: "ads"});
                        //var url = await helper.getUserImage(UserData.id);
                        socket.to(roomId).emit('response', {
                            user_id: UserData.id,
                            image: [],
                            full_name: UserData.name,
                            user_type: UserData.type,
                            type: DataType,
                            text: !isEmpty(data.message) ? data.message : null,
                            medias: []
                        });

                        console.log()
                    }

                    //message
                    if (data.message) {
                        console.log("add message success");
                        await messageText.create({
                            Text: data.message,
                            message_id: M_caht.id
                        }, {transaction: t}).then(() => {
                            console.log("add message Text  success");
                        });

                        let RoomUsers = await sequelize.query("select user_id from room_members where user_id !=:user_id and room_id =:room_id", {
                            replacements: {
                                user_id: userId,
                                room_id: RoomData.id
                            }, type: sequelize.QueryTypes.SELECT
                        });
                        RoomUsers.map(async (user) => {
                            if (user.user_id) {
                                let user_id = user.user_id;
                                // let token = await helper.getUserToken(user_id);
                                // let device_token = token.device_token;
                                // await customNotifcation.add(device_token, socket.request.user.id, data.message)
                            }
                        })
                    }
                })
            })
        }).catch(function (err) {
            console.log(err)
        });
    });

    async function getMediaType(mime) {
        let type = 0;

        switch (mime) {
            case getExt(mime, "image") :
                type = 2
                break;
            case getExt(mime, "video") :
                type = 3
                break;
            case getExt(mime, "audio") :
                type = 4
                break;
            case getExt(mime, "application") :
                type = 5
                break;
            default :
                type = 6;
        }
        console.log(type);
        return type;
    }


    function getMainType(data) {
        let type2 = 1;
        if (!isEmpty(data.image) && data.message) {
            type2 = 3;
        } else if (!isEmpty(data.image)) {
            type2 = 2
        } else if (data.message) {
            type2 = 1
        }
        return type2;
    }

    function getExt(text, type) {
        console.log(text.substr(0, text.search('/')) === type);
        if (text.substr(0, text.search('/')) === type) {
            return text.substr(0, text.search('/')) + '/' + text.substr(text.search('/') + 1)
        }
        return "error";
    }

    function check_path(path) {

        const appDir = dirname(require.main.filename);
        var dir = '/home/deliverydigisola/public_html/delivery/public/uploads/' + path;

        if (!fs.existsSync(dir)) {
            console.log("create new dir ")
            fs.mkdirSync(dir);
        }
    }

}
