const UserChat = require('../../models/userChat');
const RoomMember = require('../../models/roomMember');
const Room = require('../../models/room');
const RequestSupport = require('../../models/requestSupport');
const Message = require('../../models/message');
const Media = require('../../models/media');
const User = require('../../models/user');
const messageText = require('../../models/messageText');
const {sequelize, DataTypes} = require("../../utiles/database");
const helper = require('../../utiles/helper');
    // const fileType = require("file-type");
const {isEmpty} = require("lodash");
const customNotifcation = require("../FirebaseNotification/custom-notifcation")
const {response} = require("express");


exports.send = (socket) => {

    socket.on('AssignSupportToChat', async (data) => {
        console.log("++++++++++++++++++++++++++++");
        console.log(data.support_id);
        console.log(data.roomid);
        console.log("++++++++++++++++++++++++++++");

            const supportUser = {status: 2};
            const room = Room.findOne({
                where: {room_id: data.roomid}
            }).then(userData => {
                RequestSupport.update(supportUser, {
                    where: {
                        support_id: data.support_id,
                        room_id: userData.id,
                        status: 1
                    }
                })

                socket.emit("successAssign", {"status": 2})
            })


    });
    socket.on('SupportChatDone',async (data)=>{

        const room = Room.findOne({
            where: { room_id : data.roomid}
        }).then(userData => {
            const supportUser = { status : 3};
            RequestSupport.update(supportUser, { where: { support_id: data.support_id, room_id : userData.id} })
            socket.emit("successChatDone", {"status": 3})

        });
    })

}
