const {Model, DataTypes, sequelize} = require('../utiles/database')

class Branch extends Model {
}

Branch.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    latitude: {
        type: DataTypes.CHAR,
        allowNull: true,
    },
    longitude: {
        type: DataTypes.CHAR,
        allowNull: true,
    }

}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName: "branches_stores"});

module.exports = Branch;

