const {Model, DataTypes, sequelize} = require('../utiles/database')

class Order extends Model {
}

Order.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    Status: {
        type: DataTypes.INTEGER,
        allowNull: false,
    },
    branch_id: {
        type: DataTypes.INTEGER,
        allowNull: false,
    },
    DropOffAddressLat: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },
    DropOffAddressLong: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },


}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName: "orders"});

module.exports = Order;

