const {Model, DataTypes, sequelize} = require('../utiles/database')

class OrderDrivers extends Model {
}

OrderDrivers.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    status: {
        type: DataTypes.INTEGER,
        allowNull: false,
    },
    type: {
        type: DataTypes.INTEGER,
        allowNull: false,
    },
    driver_id: {
        type: DataTypes.BIGINT,
        allowNull: false,
    },
    order_id: {
        type: DataTypes.BIGINT,
        allowNull: false,
    }


}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName: "order_drivers"});

module.exports = OrderDrivers;

