const {Model, DataTypes, sequelize} = require('../utiles/database')

class Order_shipment extends Model {
}

Order_shipment.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    status: {
        type: DataTypes.INTEGER,
        allowNull: false,
    },
    lat_pick_up: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },
    long_pick_up: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },
    lat_drop_off: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },
    long_drop_off: {
        type: DataTypes.DECIMAL,
        allowNull: false,
    },


}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName: "order_shipments"});

module.exports = Order_shipment;

