const Branch = require("../models/branch")
const OrderDriver = require("../models/order_drivers")
const {calculateDistanceInMeters} = require("../utiles/helper");
exports.getLocationByBranch = async (currentLatitude, currentLongitude, Orders, socket, TrackOrderspace) => {
    let id = socket.handshake.headers['id'];

    for (const order of Orders) {
        let branch_id = order.branch_id
        // console.log(currentLatitude)
        // console.log(currentLongitude)
        await Branch.findOne({where: {id: branch_id}}).then(data => {
            let latitude = data.latitude;
            let longitude = data.longitude;
            // console.log(longitude)
            // console.log(latitude)
            let distanceInMeters = calculateDistanceInMeters(currentLatitude, currentLongitude, latitude, longitude)
            console.log(distanceInMeters);
            if (distanceInMeters <= 20) {
                OrderDriver.findOne({
                    where: {
                        order_id: order.id,
                        status: -1,
                    }
                }).then(dataDriver => {
                    if (dataDriver) {
                        dataDriver.status = 0;
                        dataDriver.save()
                        console.log('driver_id+++++++++++++++' + dataDriver.driver_id);
                        console.log(dataDriver);
                        TrackOrderspace.to(`driver_id${id}`).emit("track-order", {
                            "order_id": dataDriver.order_id,
                            "type": dataDriver.type
                        });
                    }
                });
            }
        });

    }
}
