const repository = require("../repositories/TrackOrder")
//
const OrderDriver = require("../models/order_drivers")
const Branch = require("../models/branch")
const Order = require("../models/order")
const OrderShipment = require("../models/order_shipment")
const {calculateDistanceInMeters} = require("../utiles/helper");


exports.track = (socket, TrackOrderspace) => {
    let id = socket.handshake.headers['id'];
    // socket.emit("track-order", 1234);
    socket.on('add-location', async (data) => {
        console.log("sssssssssssssssssssss add 1")
        console.log("is location ex" + data.latitude + " -- " + data.longitude)
        Order.findAll().then(Orders => {
            // console.log("track =====> Order" + Order);
            // console.log(Order)
            let result = repository.getLocationByBranch(data.latitude, data.longitude, Orders, socket, TrackOrderspace);
            for (const order of Orders) {
                let distanceInMeters = calculateDistanceInMeters(data.latitude, data.longitude, order.DropOffAddressLat, order.DropOffAddressLong)
                if (distanceInMeters <= 20) {
                    OrderDriver.findOne({
                        where: {
                            order_id: order.id,
                            status: -1,
                        }
                    }).then(dataDriver => {
                        if (dataDriver) {
                            dataDriver.status = 0;
                            dataDriver.save()
                            console.log('driver_id+++++++++++++++' + dataDriver.driver_id);
                            console.log(dataDriver);
                            TrackOrderspace.to(`driver_id${id}`).emit("track-order", {
                                "order_id": dataDriver.order_id,
                                "type": dataDriver.type
                            });
                        }
                    });

                    OrderDriver.findOne({
                        where: {
                            order_id: order.id,
                            status: 2,
                        }
                    }).then(dataDriver => {
                        if (dataDriver) {
                            dataDriver.status = 3;
                            dataDriver.save()
                            console.log('driver_id+++++++++++++++' + dataDriver.driver_id);
                            console.log(dataDriver);
                            TrackOrderspace.to(`driver_id${id}`).emit("track-order", {
                                "order_id": dataDriver.order_id,
                                "type": dataDriver.type
                            });
                        }
                    });
                }
            }
        })
        OrderShipment.findAll().then(OrdersShipment => {
            for (const Shipment of OrdersShipment) {
                let distanceInMeters = calculateDistanceInMeters(data.latitude, data.longitude, Shipment.lat_pick_up, Shipment.long_pick_up)
                if (distanceInMeters <= 20) {
                    OrderDriver.findOne({
                        where: {
                            order_id: Shipment.id,
                            status: -1,
                        }
                    }).then(dataDriver => {
                        if (dataDriver) {
                            dataDriver.status = 0;
                            dataDriver.save()
                            console.log('driver_id+++++++++++++++' + dataDriver.driver_id);
                            console.log(dataDriver);
                            TrackOrderspace.to(`driver_id${id}`).emit("track-order", {
                                "order_id": dataDriver.order_id,
                                "type": dataDriver.type
                            });
                        }
                    });

                    for (const Shipment of OrdersShipment) {
                        let distanceInMeters = calculateDistanceInMeters(data.latitude, data.longitude, Shipment.lat_drop_off, Shipment.long_drop_off)
                        if (distanceInMeters <= 20) {
                            OrderDriver.findOne({
                                where: {
                                    order_id: Shipment.id,
                                    status: 2,
                                }
                            }).then(dataDriver => {
                                if (dataDriver) {
                                    dataDriver.status = 3;
                                    dataDriver.save()
                                    console.log('driver_id+++++++++++++++' + dataDriver.driver_id);
                                    console.log(dataDriver);
                                    TrackOrderspace.to(`driver_id${id}`).emit("track-order", {
                                        "order_id": dataDriver.order_id,
                                        "type": dataDriver.type
                                    });
                                }
                            });

                        }
                    }
                }
            }
        });
        OrderShipment.findAll().then(OrdersShipment => {
            for (const Shipment of OrdersShipment) {
                let distanceInMeters = calculateDistanceInMeters(data.latitude, data.longitude, Shipment.lat_pick_up, Shipment.long_pick_up)
                if (distanceInMeters <= 20) {

                    for (const Shipment of OrdersShipment) {
                        let distanceInMeters = calculateDistanceInMeters(data.latitude, data.longitude, Shipment.lat_drop_off, Shipment.long_drop_off)
                        if (distanceInMeters <= 20) {
                            OrderDriver.findOne({
                                where: {
                                    order_id: Shipment.id,
                                    status: 42,
                                }
                            }).then(dataDriver => {
                                if (dataDriver) {
                                    dataDriver.status = 3;
                                    dataDriver.save()
                                    console.log('driver_id+++++++++++++++' + dataDriver.driver_id);
                                    console.log(dataDriver);
                                    TrackOrderspace.to(`driver_id${id}`).emit("track-order", {
                                        "order_id": dataDriver.order_id,
                                        "type": dataDriver.type
                                    });
                                }
                            });

                        }
                    }
                }
            }
        });

    });
}
