const {Model, DataTypes, sequelize} = require('../utiles/database')

class requestSupport extends Model {}

requestSupport.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    user_id: {
        type: DataTypes.BIGINT,
        allowNull: false,
    },
    room_id: {
        type: DataTypes.STRING,
        allowNull: false,
    },
    status: {
        type: DataTypes.TINYINT,
        allowNull: false,
    },
}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName:"request_support"});

module.exports = requestSupport;

