const {Model, DataTypes, sequelize} = require('../utiles/database')

class SupportDriver extends Model {
}

SupportDriver.init({
    id: {
        type: DataTypes.BIGINT,
        allowNull: false,
        unsigned: true,
        autoIncrement: true,
        primaryKey: true
    },
    lat: {
        type: DataTypes.CHAR,
        allowNull: true,
    },
    long: {
        type: DataTypes.CHAR,
        allowNull: true,
    },
    driver_id: {
        type: DataTypes.BIGINT,
        allowNull: true,
    }

}, {sequelize, createdAt: "created_at", updatedAt: "updated_at", tableName: "support_drivers"});

module.exports = SupportDriver;

